Index: sasmodels/models/barbell.py
===================================================================
--- sasmodels/models/barbell.py	(revision fcb33e4672814b4a8fe1ee865d430090b5fc03e6)
+++ sasmodels/models/barbell.py	(revision 0b56f3871b1019e3bb99fb618e1342d5f26c8de4)
@@ -87,5 +87,5 @@
 * **Last Reviewed by:** Richard Heenan **Date:** January 4, 2017
 """
-from numpy import inf
+from numpy import inf, sin, cos, pi
 
 name = "barbell"
@@ -125,2 +125,10 @@
             phi_pd=15, phi_pd_n=0,
            )
+q = 0.1
+# april 6 2017, rkh add unit tests, NOT compared with any other calc method, assume correct!
+qx = q*cos(pi/6.0)
+qy = q*sin(pi/6.0)
+tests = [[{}, 0.075, 25.5691260532],
+        [{'theta':80., 'phi':10.}, (qx, qy), 3.04233067789],
+        ]
+del qx, qy  # not necessary to delete, but cleaner
Index: sasmodels/models/bcc_paracrystal.py
===================================================================
--- sasmodels/models/bcc_paracrystal.py	(revision 925ad6edca2969db8fb763eb02beee2c5a5f2872)
+++ sasmodels/models/bcc_paracrystal.py	(revision 0b56f3871b1019e3bb99fb618e1342d5f26c8de4)
@@ -99,5 +99,5 @@
 """
 
-from numpy import inf
+from numpy import inf, pi
 
 name = "bcc_paracrystal"
@@ -141,2 +141,8 @@
     psi_pd=15, psi_pd_n=0,
     )
+# april 6 2017, rkh add unit tests, NOT compared with any other calc method, assume correct!
+q =4.*pi/220.
+tests = [
+    [{ },
+     [0.001, q, 0.215268], [1.46601394721, 2.85851284174, 0.00866710287078]],
+]
Index: sasmodels/models/capped_cylinder.py
===================================================================
--- sasmodels/models/capped_cylinder.py	(revision fcb33e4672814b4a8fe1ee865d430090b5fc03e6)
+++ sasmodels/models/capped_cylinder.py	(revision 0b56f3871b1019e3bb99fb618e1342d5f26c8de4)
@@ -91,5 +91,5 @@
 
 """
-from numpy import inf
+from numpy import inf, sin, cos, pi
 
 name = "capped_cylinder"
@@ -145,2 +145,10 @@
             theta_pd=15, theta_pd_n=45,
             phi_pd=15, phi_pd_n=1)
+q = 0.1
+# april 6 2017, rkh add unit tests, NOT compared with any other calc method, assume correct!
+qx = q*cos(pi/6.0)
+qy = q*sin(pi/6.0)
+tests = [[{}, 0.075, 26.0698570695],
+        [{'theta':80., 'phi':10.}, (qx, qy), 0.561811990502],
+        ]
+del qx, qy  # not necessary to delete, but cleaner
Index: sasmodels/models/core_shell_bicelle.py
===================================================================
--- sasmodels/models/core_shell_bicelle.py	(revision 8afefaee3d363dde220aa55fe83181a73b621f98)
+++ sasmodels/models/core_shell_bicelle.py	(revision 0b56f3871b1019e3bb99fb618e1342d5f26c8de4)
@@ -88,5 +88,5 @@
 """
 
-from numpy import inf, sin, cos
+from numpy import inf, sin, cos, pi
 
 name = "core_shell_bicelle"
@@ -155,4 +155,11 @@
             theta=90,
             phi=0)
+q = 0.1
+# april 6 2017, rkh add unit tests, NOT compared with any other calc method, assume correct!
+qx = q*cos(pi/6.0)
+qy = q*sin(pi/6.0)
+tests = [[{}, 0.05, 7.4883545957],
+        [{'theta':80., 'phi':10.}, (qx, qy), 2.81048892474 ],
+        ]
+del qx, qy  # not necessary to delete, but cleaner
 
-#qx, qy = 0.4 * cos(pi/2.0), 0.5 * sin(0)
Index: sasmodels/models/core_shell_bicelle_elliptical.py
===================================================================
--- sasmodels/models/core_shell_bicelle_elliptical.py	(revision 8afefaee3d363dde220aa55fe83181a73b621f98)
+++ sasmodels/models/core_shell_bicelle_elliptical.py	(revision 0b56f3871b1019e3bb99fb618e1342d5f26c8de4)
@@ -99,5 +99,5 @@
 """
 
-from numpy import inf, sin, cos
+from numpy import inf, sin, cos, pi
 
 name = "core_shell_bicelle_elliptical"
@@ -150,5 +150,8 @@
             psi=0)
 
-#qx, qy = 0.4 * cos(pi/2.0), 0.5 * sin(0)
+q = 0.1
+# april 6 2017, rkh added a 2d unit test, NOT READY YET pull #890 branch assume correct!
+qx = q*cos(pi/6.0)
+qy = q*sin(pi/6.0)
 
 tests = [
@@ -159,3 +162,6 @@
     'sld_core':4.0, 'sld_face':7.0, 'sld_rim':1.0, 'sld_solvent':6.0, 'background':0.0},
     0.015, 286.540286],
-]
+#    [{'theta':80., 'phi':10.}, (qx, qy), 7.88866563001 ],
+        ]
+
+del qx, qy  # not necessary to delete, but cleaner
Index: sasmodels/models/core_shell_cylinder.py
===================================================================
--- sasmodels/models/core_shell_cylinder.py	(revision 8e68ea06a7246c4bd95ce82c755719ced6fa5a60)
+++ sasmodels/models/core_shell_cylinder.py	(revision 0b56f3871b1019e3bb99fb618e1342d5f26c8de4)
@@ -73,5 +73,5 @@
 """
 
-from numpy import pi, inf
+from numpy import pi, inf, sin, cos
 
 name = "core_shell_cylinder"
@@ -151,3 +151,10 @@
             theta_pd=15, theta_pd_n=45,
             phi_pd=15, phi_pd_n=1)
-
+q = 0.1
+# april 6 2017, rkh add unit tests, NOT compared with any other calc method, assume correct!
+qx = q*cos(pi/6.0)
+qy = q*sin(pi/6.0)
+tests = [[{}, 0.075, 10.8552692237],
+        [{}, (qx, qy), 0.444618752741 ],
+        ]
+del qx, qy  # not necessary to delete, but cleaner
Index: sasmodels/models/ellipsoid.py
===================================================================
--- sasmodels/models/ellipsoid.py	(revision 4b0a294be46e951df4767202737d3e713c14ee28)
+++ sasmodels/models/ellipsoid.py	(revision 0b56f3871b1019e3bb99fb618e1342d5f26c8de4)
@@ -120,5 +120,5 @@
 """
 
-from numpy import inf
+from numpy import inf, sin, cos, pi
 
 name = "ellipsoid"
@@ -190,2 +190,10 @@
             theta_pd=15, theta_pd_n=45,
             phi_pd=15, phi_pd_n=1)
+q = 0.1
+# april 6 2017, rkh add unit tests, NOT compared with any other calc method, assume correct!
+qx = q*cos(pi/6.0)
+qy = q*sin(pi/6.0)
+tests = [[{}, 0.05, 54.8525847025],
+        [{'theta':80., 'phi':10.}, (qx, qy), 1.74134670026 ],
+        ]
+del qx, qy  # not necessary to delete, but cleaner
Index: sasmodels/models/elliptical_cylinder.py
===================================================================
--- sasmodels/models/elliptical_cylinder.py	(revision fcb33e4672814b4a8fe1ee865d430090b5fc03e6)
+++ sasmodels/models/elliptical_cylinder.py	(revision 0b56f3871b1019e3bb99fb618e1342d5f26c8de4)
@@ -108,5 +108,5 @@
 """
 
-from numpy import pi, inf, sqrt
+from numpy import pi, inf, sqrt, sin, cos
 
 name = "elliptical_cylinder"
@@ -149,4 +149,8 @@
                            + (length + radius) * (length + pi * radius))
     return 0.5 * (ddd) ** (1. / 3.)
+q = 0.1
+# april 6 2017, rkh added a 2d unit test, NOT READY YET pull #890 branch assume correct!
+qx = q*cos(pi/6.0)
+qy = q*sin(pi/6.0)
 
 tests = [
@@ -158,3 +162,4 @@
       'sld_solvent':1.0, 'background':0.0},
      0.001, 675.504402],
+#    [{'theta':80., 'phi':10.}, (qx, qy), 7.88866563001 ],
 ]
Index: sasmodels/models/hollow_cylinder.py
===================================================================
--- sasmodels/models/hollow_cylinder.py	(revision aea2e2ab3f11c42b7fc1a72a02b6784076c41d3a)
+++ sasmodels/models/hollow_cylinder.py	(revision 0b56f3871b1019e3bb99fb618e1342d5f26c8de4)
@@ -60,5 +60,5 @@
 """
 
-from numpy import pi, inf
+from numpy import pi, inf, sin, cos
 
 name = "hollow_cylinder"
@@ -129,9 +129,14 @@
             theta_pd=10, theta_pd_n=5,
            )
-
+q = 0.1
+# april 6 2017, rkh added a 2d unit test, assume correct!
+qx = q*cos(pi/6.0)
+qy = q*sin(pi/6.0)
 # Parameters for unit tests
 tests = [
     [{}, 0.00005, 1764.926],
     [{}, 'VR', 1.8],
-    [{}, 0.001, 1756.76]
-    ]
+    [{}, 0.001, 1756.76],
+    [{}, (qx, qy), 2.36885476192  ],
+        ]
+del qx, qy  # not necessary to delete, but cleaner
Index: sasmodels/models/stacked_disks.py
===================================================================
--- sasmodels/models/stacked_disks.py	(revision b7e8b94b477e6d9a7e4e2666bb218d3568ee66d2)
+++ sasmodels/models/stacked_disks.py	(revision 0b56f3871b1019e3bb99fb618e1342d5f26c8de4)
@@ -103,5 +103,5 @@
 """
 
-from numpy import inf
+from numpy import inf, sin, cos, pi
 
 name = "stacked_disks"
@@ -152,5 +152,8 @@
 # After redefinition of spherical coordinates -
 # tests had in old coords theta=0, phi=0; new coords theta=90, phi=0
-# but should not matter here as so far all the tests are 1D not 2D
+q = 0.1
+# april 6 2017, rkh added a 2d unit test, assume correct!
+qx = q*cos(pi/6.0)
+qy = q*sin(pi/6.0)
 tests = [
 # Accuracy tests based on content in test/utest_extra_models.py.
@@ -186,4 +189,17 @@
     [{'thick_core': 10.0,
       'thick_layer': 15.0,
+      'radius': 100.0,
+      'n_stacking': 5,
+      'sigma_d': 0.0,
+      'sld_core': 4.0,
+      'sld_layer': -0.4,
+      'solvent_sd': 5.0,
+      'theta': 90.0,
+      'phi': 20.0,
+      'scale': 0.01,
+      'background': 0.001},
+      (qx, qy), 0.0491167089952  ],
+    [{'thick_core': 10.0,
+      'thick_layer': 15.0,
       'radius': 3000.0,
       'n_stacking': 5,
@@ -228,4 +244,17 @@
       'background': 0.001,
      }, ([0.4, 0.5]), [0.00105074, 0.00121761]],
+    [{'thick_core': 10.0,
+      'thick_layer': 15.0,
+      'radius': 3000.0,
+      'n_stacking': 1.0,
+      'sigma_d': 0.0,
+      'sld_core': 4.0,
+      'sld_layer': -0.4,
+      'solvent_sd': 5.0,
+      'theta': 90.0,
+      'phi': 20.0,
+      'scale': 0.01,
+      'background': 0.001,
+     }, (qx, qy), 0.0341738733124 ],
 
     [{'thick_core': 10.0,
Index: sasmodels/models/triaxial_ellipsoid.py
===================================================================
--- sasmodels/models/triaxial_ellipsoid.py	(revision 4b0a294be46e951df4767202737d3e713c14ee28)
+++ sasmodels/models/triaxial_ellipsoid.py	(revision 0b56f3871b1019e3bb99fb618e1342d5f26c8de4)
@@ -112,5 +112,5 @@
 """
 
-from numpy import inf
+from numpy import inf, sin, cos, pi
 
 name = "triaxial_ellipsoid"
@@ -166,2 +166,11 @@
             phi_pd=15, phi_pd_n=1,
             psi_pd=15, psi_pd_n=1)
+q = 0.1
+# april 6 2017, rkh add unit tests, NOT compared with any other calc method, assume correct!
+# add 2d test after pull #890
+qx = q*cos(pi/6.0)
+qy = q*sin(pi/6.0)
+tests = [[{}, 0.05, 24.8839548033],
+#        [{'theta':80., 'phi':10.}, (qx, qy), 9999. ],
+        ]
+del qx, qy  # not necessary to delete, but cleaner
